#include "application.h"

#include <iostream>
#include <cassert>

using namespace std;

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#include "vector3.h"

application::application()
{
    cout << "COMMANDS: " << endl;
    cout << "\tc: clears the buffer and rerenders" << endl << endl;
}

application::~application()
{
}

void application::draw_event()
{
    cout << "clearing and rerendering" << endl;

    glColor3f(1.0, 1.0, 1.0);
    for (int i = 0; i < this->width; ++i)
    {
        glBegin(GL_POINTS);
        glVertex2f(i, 40); // bottom line
        glVertex2f(i, this->height - 40); // top line
        glEnd();
        
        // Add some delay to see the pixels as they are being drawn.
        // Your raytracer will have a natural delay and you will
        // be able to see your sceen being drawn without the following code.
        for (int i = 0; i < 1000000; ++i);
        
        // This command empties the GL draw buffer out to screen
        // You should call this after each raytraced pixel value
        // is filled in to see the rendering as it progresses.
        // Before we were using double-buffering and when we called
        // glutSwapBuffers the draw commands were automatically
        // flushed to the back buffer for us.
        glFlush();
    }
}

void application::keyboard_event(unsigned char key, int x, int y)
{
    // rerender
    if (key == 'c')
        glutPostRedisplay();
}
